/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#ifndef __ADDIN_H_
#define __ADDIN_H_

#include "resource.h"       // main symbols

#if defined(OUTLOOK2000)
#import "C:\Programmi\File comuni\Designer\MSADDNDR.DLL" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#elif defined(OUTLOOK2003)
#import "..\\lib\\msoffice\\outlook2003\\MSADDNDR.DLL" raw_interfaces_only, raw_native_types, no_namespace, named_guids
#endif
/////////////////////////////////////////////////////////////////////////////

extern _ATL_FUNC_INFO OnClickButtonInfo;
extern _ATL_FUNC_INFO OnClickSynchronizationInfo;
extern _ATL_FUNC_INFO OnClickConfigurationInfo;

// Caddin
class ATL_NO_VTABLE Caddin :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Caddin, &CLSID_addin>,
	public ISupportErrorInfo,
	public IDispatchImpl<Iaddin, &IID_Iaddin, &LIBID_FUNAMBOLADDINLib>,
	public IDispatchImpl<_IDTExtensibility2, &IID__IDTExtensibility2, &LIBID_AddInDesignerObjects>,
    public IDispEventSimpleImpl<1,Caddin,&__uuidof(_CommandBarButtonEvents)>,
    public IDispEventSimpleImpl<2,Caddin,&__uuidof(_CommandBarButtonEvents)>,
    public IDispEventSimpleImpl<3,Caddin,&__uuidof(_CommandBarButtonEvents)>

{
public:

    typedef IDispEventSimpleImpl</*nID =*/ 1,Caddin, &__uuidof(_CommandBarButtonEvents)> ButtonSyncEvent;
    typedef IDispEventSimpleImpl</*nID =*/ 2,Caddin, &__uuidof(_CommandBarButtonEvents)> ItemSynchronizationEvent;
    typedef IDispEventSimpleImpl</*nID =*/ 3,Caddin, &__uuidof(_CommandBarButtonEvents)> ItemConfigurationEvent;

	Caddin()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Caddin)
	COM_INTERFACE_ENTRY(Iaddin)
//DEL 	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY2(IDispatch, Iaddin)
	COM_INTERFACE_ENTRY(_IDTExtensibility2)
END_COM_MAP()

BEGIN_SINK_MAP(Caddin)
SINK_ENTRY_INFO(1, __uuidof(_CommandBarButtonEvents),/*dispid*/ 0x01, OnClickButton, &OnClickButtonInfo)
SINK_ENTRY_INFO(2, __uuidof(_CommandBarButtonEvents),/*dispid*/ 0x01, OnClickSynchronization, &OnClickSynchronizationInfo)
SINK_ENTRY_INFO(3, __uuidof(_CommandBarButtonEvents),/*dispid*/ 0x01, OnClickConfiguration, &OnClickConfigurationInfo)

END_SINK_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// Iaddin
    void __stdcall OnClickButton(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault);
    void __stdcall OnClickSynchronization(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault);
    void __stdcall OnClickConfiguration(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault);

public:
// _IDTExtensibility2
	STDMETHOD(OnConnection)(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch * AddInInst, SAFEARRAY * * custom);

	STDMETHOD(OnDisconnection)(ext_DisconnectMode RemoveMode, SAFEARRAY * * custom);

    STDMETHOD(OnAddInsUpdate)(SAFEARRAY * * custom)
	{
		return E_NOTIMPL;
	}
	STDMETHOD(OnStartupComplete)(SAFEARRAY * * custom);

	STDMETHOD(OnBeginShutdown)(SAFEARRAY * * custom);

    HRESULT AddNewMenubar(_CommandBars *pCmdBars);
    HRESULT DeleteMenubar(_CommandBars *pCmdBars);

    HRESULT __stdcall Caddin::DispAdviseControls(void);

	HRESULT __stdcall Caddin::DispUnadviseControls(void);

    void launchSyncClientOutlook(wchar_t* parameter);

    HRESULT removeAddin();
    int getAddinState();
    int setAddinState(int value);

private:
    LPDISPATCH      m_pParentApp;
    _ApplicationPtr applicationPtr;

};

#endif //__ADDIN_H_
