Attribute VB_Name = "mdLoad"
'
' Copyright (C) 2003-2006 Funambol
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdLoad.bas                                           *
'*                                                              *
'*This module contains all the functions used during the load   *
'*procedure for the frmPrepare Form.                            *
'*These functions were the intermediate steps for reading       *
'*the Items Properties file and for reading all the MAPI folders*
'*existent inside Outlook Default Profile.                      *
'****************************************************************

Option Explicit

Sub Main()

Dim Args As String
Args = Command()

'True if this instance is called from Windows scheduler
If Len(Args) > 0 And Args = "schedule" Then
    isSchedule = True
Else
    isSchedule = False
End If

'Only 1 instance of Outlook Plugin allowed
If IsPluginAlreadyRunning = True Then
    If isSchedule = False Then
        MsgBox ("Funambol Outlook Plugin already running!")
    End If
    End
End If

Dim productName As String
Dim ret As Integer
productName = mdMMVariables.ABOUT_PRODUCT_NAME + mdMMVariables.getVersion

'to open log file in dll
ret = openLog(mdMMVariables.AppPath(), productName)
If (ret) Then
    MsgBox ("An error occurred during Plugin start-up." + Chr(13) + "Funambol Outlook Plugin will now exit.")
    End
End If


If isSchedule = True Then
    frmMMSync.Hide
    frmMMSync.synchronize
    mdUnload.closeProgram
ElseIf Len(Args) > 0 And Args = "outlook" Then 'called from button from outlook
    
    ret = frmMMSync.loadConfig
    
    '1 ok, 2 cancel
    If ret = 1 Then
       frmMMSetting.Show 1
       frmMMSync.Show
       Exit Sub
    ElseIf ret = 2 Then
        frmMMSync.Show
        Exit Sub
    End If
    
    frmMMSync.WindowState = 1   'minimize
    frmMMSync.Show
    frmMMSync.synchronize
    
    If frmMMSync.StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_END Then
        Wait (5)
        mdUnload.closeProgram
    Else
        frmMMSync.WindowState = 0   'normal
        frmMMSync.Show
    End If
    
Else

    frmMMSync.Show
End If

End Sub
Sub loadListForProperties()
    'read from item_for_properties.db file all the item properties available for user

If doesFileExist(mdVariables.NAME_PROPERTIES_LIST_FILE) Then
    mdFileSystem.readAllItemPropertiesForUser mdVariables.NAME_PROPERTIES_LIST_FILE
Else 'if file doesn't exist, the application ends
    MsgBox "Main file for Item Properties missing. SyncClient Outlook ends.", vbExclamation
    mdUnload.closeProgram
End If

End Sub

Sub readAllFolders()
    'read the existent folders and subfolders of the 4 types
    '(Calendar, Contacts, Mail, Tasks)
    'and save their EntryID and Name in the arrays of relative type

printDebugMessage "Starting readAllFolders procedure"
Dim countMailFolders As Integer
Dim referFolders As Outlook.MAPIFolder, objFolder As Outlook.MAPIFolder

On Error GoTo readAllFolders_Err

'this prepares the counters for all the folders for mail type
'in order to redim the mail array
countMailFolders = 0

'read the existent subfolders for Calendar default folder
'and save all the EntryIDs and names in calendarFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"

'ReDim the array in order to prepare it for the recursive function readOLFolders
ReDim mdVariables.calendarFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar)))
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar), mdVariables.calendarFolders
'read the existent subfolders for Contacts default folder
'and save all the EntryIDs and names in contactsFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"
'ReDim the array in order to prepare it for the recursive function readOLFolders

ReDim mdVariables.contactsFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderContacts)))
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderContacts), mdVariables.contactsFolders

'read the existent subfolders for Mail default folder
'and all the other user mail folders
'and save all the EntryIDs and names in mailFolders array

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'mdVariables.publicCounter = 1
'mdVariables.publicRecounter = 0
'mdVariables.readFolderLevel = 0
'mdVariables.readFolderPath = "/"
''get a reference to the default MAPI folders collection,
''containing the default felders for the current profile
'Set referFolders = mdVariables.nameSpace.Folders.Item(1)
''read all folders and count the mail type ones
'For Each objFolder In referFolders.Folders
'    If objFolder.DefaultItemType = olMailItem Then
'        countMailFolders = countMailFolders + mdSyncAgent.countFolders(objFolder)
'    End If
'Next objFolder
''ReDim the array in order to prepare it for the recursive function readOLFolders
''ReDim mdVariables.mailFolders(countMailFolders)
'For Each objFolder In referFolders.Folders
'    If objFolder.DefaultItemType = olMailItem Then
'        'mdSyncAgent.readOLFolders objFolder, mdVariables.mailFolders
'    End If
'Next objFolder

'read the existent subfolders for Tasks default folder
'and save all the EntryIDs and names in tasksFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"
'ReDim the array in order to prepare it for the recursive function readOLFolders
ReDim mdVariables.tasksFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderTasks)))
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderTasks), mdVariables.tasksFolders
'read the existent subfolders for Notes default folder
'and save all the EntryIDs and names in notesFolders array
mdVariables.publicCounter = 1
mdVariables.publicRecounter = 0
mdVariables.readFolderLevel = 0
mdVariables.readFolderPath = "/"
'ReDim the array in order to prepare it for the recursive function readOLFolders
ReDim mdVariables.notesFolders(mdSyncAgent.countFolders(mdVariables.nameSpace.GetDefaultFolder(olFolderNotes)))
mdSyncAgent.readOLFolders mdVariables.nameSpace.GetDefaultFolder(olFolderNotes), mdVariables.notesFolders

readAllFolders_Exit:
    Exit Sub

readAllFolders_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo readAllFolders_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub
