Attribute VB_Name = "mdMMServer2Client"
'
' Copyright (C) 2003-2006 Funambol
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:    mdMMServer2Client.frm                              *
'****************************************************************

' Static Public counters of items processed.
' Must be resetted by sync process.
' (used only to update status bar, we don't know #items total by now)
Public countInsertedContacts As Long
Public countInsertedAppointments As Long
Public countInsertedTasks As Long
Public countInsertedNotes As Long

Public countDeletedContacts As Long
Public countDeletedAppointments As Long
Public countDeletedTasks As Long
Public countDeletedNotes As Long

Public countUpdatedContacts As Long
Public countUpdatedAppointments As Long
Public countUpdatedTasks As Long
Public countUpdatedNotes As Long



Public Sub setAllDayEventServer2Client(ByVal key As String, ByVal value As String)
    
    mdMMVariables.isAllDayEvent = False
    
    If key = "AllDayEvent" Then
        If value <> "" Then
            If (CBool(value) = True Or value = "True" Or value = "true") Then
                mdMMVariables.isAllDayEvent = True
                Exit Sub
            End If
        End If
    End If
        
End Sub


'From server to Outlook.
'-----------------------
' Updates a single item, passed by a xml string, to Outlook (for calendar | tasks | notes)
' This is a function called from a DLL method (CALLBACK, from WindowsSyncSource.updateItem)
' @param xml: the xml string for the current item
' @return   : "0" if no errors
Function updateItem(ByVal xml As String) As String

printDebugMessage "CALLBACK: Enter updateItem method"

'Get input parameters from public variables (which source)
Dim objFolder As Outlook.MAPIFolder
Set objFolder = mdVariables.nameSpace.GetDefaultFolder(mdVariables.currentObjFolder)
Dim folderType As Integer
folderType = mdVariables.currentFolderType

Dim ret As String

Dim position As Long
Dim numItem As Integer
Dim i As Integer
Dim j As Integer
Dim Count As Integer

Dim identifier As String
Dim rowBlock As String
Dim props() As Variant
Dim K As Integer
Dim found As Boolean
       
Dim myApptItem As Outlook.AppointmentItem
Dim myContactItem As Outlook.ContactItem
Dim myTaskItem As Outlook.TaskItem
Dim myNoteItem As Outlook.NoteItem
Dim myRecurrPAtt As Outlook.RecurrencePattern
Dim createdEntryID  As String
Dim res As String

Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    ChangeStatusBar WAIT_UPDATE_CALENDAR + "(" + Trim(Str(countUpdatedAppointments + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    Count = mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar).Items.Count
    
Case mdVariables.FOLDER_TYPE_TASK
    ChangeStatusBar WAIT_UPDATE_TASK + "(" + Trim(Str(countUpdatedTasks + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    Count = mdVariables.nameSpace.GetDefaultFolder(olFolderTasks).Items.Count

Case mdVariables.FOLDER_TYPE_NOTE
    ChangeStatusBar WAIT_UPDATE_NOTE + "(" + Trim(Str(countUpdatedNotes + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    Count = mdVariables.nameSpace.GetDefaultFolder(olFolderNotes).Items.Count
    
Case mdVariables.FOLDER_TYPE_CON
    updateItem = "-1"                  'error
    Exit Function
End Select

i = 0
position = 1
updateItem = "-1"

ret = getElementContent(xml, "MOD", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    
    'Expected ONLY 1 Item to update
    If Val(numItem) = 1 Then
    
        rowBlock = getElementContent(ret, "row", position)
        identifier = getElementContent(rowBlock, "identifier", 0)
        
        If folderType = FOLDER_TYPE_CAL Then
            props(0, 0) = "Class"
            props(0, 1) = 26
            
            'for recurrence
            Dim RecProps() As Variant
            ReDim RecProps(0 To 10, 0 To 1)
            mdMMServer2Client.populateRecProps RecProps, rowBlock
            
            'used for allDayEvent. If set then the startDate and endDate should be without time and with
            'end date without a day
            mdMMServer2Client.setAllDayEventServer2Client "AllDayEvent", getElementContent(rowBlock, "AllDayEvent", 0)
                
        End If
        
        'for debug
        Dim subj As String
        subj = getElementContent(rowBlock, "Subject", 0)
        printDebugMessage "Item: " + subj
        '
        Dim s As String
        Dim tmp As Variant
        Dim secondValue As Variant
        
        For K = 1 To UBound(props)
                
            If folderType = FOLDER_TYPE_CAL Then
                
                tmp = Empty
                secondValue = Empty
                
                props(K, 0) = mdVariables.calendarProperties(K).Property
                If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) Then
                    props(K, 1) = getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                Else
                    'put right type to every property. If date is empty put nothing
                    secondValue = getElementContent(rowBlock, mdVariables.calendarProperties(K).Property, 0)
                
                    If IsEmpty(secondValue) = False Then
                        tmp = returnElementDataTypeCorrect(props(K, 0), _
                            secondValue)
                    End If
                    
                    'tmp = returnElementDataTypeCorrect(props(K, 0), _
                    '    getElementContent(rowBlock, mdVariables.calendarProperties(K).Property, 0))
                    
                    props(K, 1) = tmp
                End If
                
                'used for allDayEvent. If set then the startDate and endDate should be without time and with
                ' end date without a day
                ' mdMMServer2Client.setAllDayEventServer2Client props(K, 0), props(K, 1)
                
            ElseIf folderType = FOLDER_TYPE_TASK Then
                                                                            
                tmp = Empty
                secondValue = Empty
                
                props(K, 0) = mdVariables.tasksProperties(K).Property
                
                secondValue = getElementContent(rowBlock, mdVariables.tasksProperties(K).Property, 0)
                
                If IsEmpty(secondValue) = False Then
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        secondValue)
                End If
                'put right type to every property. If date is empty put nothing
                'tmp = returnElementDataTypeCorrect(props(K, 0), _
                ' getElementContent(rowBlock, mdVariables.tasksProperties(K).Property, 0))
                
                props(K, 1) = tmp
            ElseIf folderType = FOLDER_TYPE_NOTE Then
                If mdVariables.notesProperties(K).Property <> "Subject" Then
                    
                    tmp = Empty
                    secondValue = Empty
                    
                    Dim tmpNote As Variant
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        secondValue = getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0)
                
                        If IsEmpty(secondValue) = False Then
                            tmp = returnElementDataTypeCorrect(props(K, 0), _
                                secondValue)
                        End If
                        
                        'tmp = returnElementDataTypeCorrect(props(K, 0), _
                        ' getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0))
                        tmpNote = defaultNoteValues(props(K, 0), tmp)
                        props(K, 1) = tmpNote

                End If
            End If
        
        Next K
                
        
        If folderType = FOLDER_TYPE_CAL Then
            If Count = 0 Then
                printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                updateItem = "-1"
            Else
            
                Set myApptItem = mdVariables.nameSpace.GetItemFromID(identifier)
                
                If myApptItem Is Nothing Then  'the item to modify was not found. It has to be created
                    printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                    updateItem = "-1"
                
                Else
                    res = mdActions.updateItemCalendar(identifier, props(), folderType)
                    updateItem = res
                    If res = "-1" Then
                        printLog ERROR_UPDATING_ITEM & rowBlock, INFO_LEVEL
                        updateItem = "-1"
                    End If

                End If
            End If
        
        
        ElseIf folderType = FOLDER_TYPE_TASK Then
            If Count = 0 Then
                printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
            Else

                Set myTaskItem = mdVariables.nameSpace.GetItemFromID(identifier)
                
                If myTaskItem Is Nothing Then  'the item to modify was not found. It has to be created
                    printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                    updateItem = "-1"
                
                Else
                    res = mdActions.updateItemCalendar(identifier, props(), folderType)
                    updateItem = res
                    If res = "-1" Then
                        printLog ERROR_UPDATING_ITEM & rowBlock, INFO_LEVEL
                        updateItem = "-1"
                    End If

                End If
                    
            End If
         
         
         ElseIf folderType = FOLDER_TYPE_NOTE Then 'modify for notes
            If Count = 0 Then
                printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
            Else
            
                Set myNoteItem = mdVariables.nameSpace.GetItemFromID(identifier)
                
                If myNoteItem Is Nothing Then  'the item to modify was not found. It has to be created
                    printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
                    updateItem = "-1"
                
                Else
                    res = mdActions.updateItem(identifier, props)
                    updateItem = res
                    If res = "-1" Then
                        printLog ERROR_UPDATING_ITEM & rowBlock, INFO_LEVEL
                        updateItem = "-1"
                    End If

                End If
            End If
            
        End If
    
    End If

End If


Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    countUpdatedAppointments = countUpdatedAppointments + 1
Case mdVariables.FOLDER_TYPE_TASK
    countUpdatedTasks = countUpdatedTasks + 1
Case mdVariables.FOLDER_TYPE_NOTE
    countUpdatedNotes = countUpdatedNotes + 1
End Select

printDebugMessage "Exit updateItem method"

End Function


'From server to Outlook.
'-----------------------
' Updates a single item, passed by a xml string, to Outlook (only for contacts)
' This is a function called from a DLL method (CALLBACK, from WindowsSyncSource.updateItem)
' @param xml: the xml string for the current item
' @return   : "0" if no errors
Function updateItemContacts(ByVal xml As String) As String

printDebugMessage "CALLBACK: Enter updateItemContacts method"

 'Get input parameters from public variables (this function is only for CONTACTS)
Dim folderType As Integer
folderType = mdVariables.FOLDER_TYPE_CON

Dim res As String
Dim ret As String

Dim position As Long
Dim numItem As Integer
Dim i As Integer
Dim j As Integer


Dim identifier As String
Dim rowBlock As String
Dim props() As Variant
Dim K As Integer
Dim found As Boolean
       
Dim myContactItem As Outlook.ContactItem
Dim createdEntryID  As String
             
Select Case folderType
Case mdVariables.FOLDER_TYPE_CON
    ChangeStatusBar WAIT_UPDATE_CONTACT + "(" + Trim(Str(countUpdatedContacts + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
End Select

i = 0
position = 1
updateItemContacts = "-1"

On Error Resume Next

ret = getElementContent(xml, "MOD", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    
    'Expected ONLY 1 item to update
    If Val(numItem) = 1 Then
        myContactItem = Nothing
        
        rowBlock = getElementContent(ret, "row", position)
        identifier = getElementContent(rowBlock, "identifier", 0)
        
         'for debug
        Dim subj As String
        subj = getElementContent(rowBlock, "Subject", 0)
        printDebugMessage "Item: " + subj
        
        Dim s As String
        Dim tmp As Variant
        Dim secondValue As Variant
        
        For K = 1 To UBound(props)
            If folderType = FOLDER_TYPE_CON Then
                                
                tmp = Empty
                secondValue = Empty
                
                props(K, 0) = mdVariables.contactsProperties(K).Property
                secondValue = getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0)
                
                If IsEmpty(secondValue) = False Then
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        secondValue)
                End If
                
                props(K, 1) = tmp
            End If
        
        Next K
                
        Set myContactItem = mdVariables.nameSpace.GetItemFromID(identifier)
        
        If myContactItem Is Nothing Then  'the item to modify was not found. It has to be created
            
            printLog ERROR_INSERTING_UPDATE_ITEM_AS_NEW & rowBlock, INFO_LEVEL
        
        Else
                                          
            res = mdActions.updateItem(identifier, props)
            updateItemContacts = res
                
        End If
    End If
End If

countUpdatedContacts = countUpdatedContacts + 1

printDebugMessage "Exit updateItemContacts method"

End Function

Function insertContact(ByRef rowBlock As String, ByRef props() As Variant)
                
    printDebugMessage "Enter insertContact method"
    Dim defaultFolderContacts As Outlook.MAPIFolder
    Dim itemContact As Outlook.ContactItem
    Dim referFolder As Outlook.MAPIFolder
    Dim K As Integer
    Dim createdEntryID As String
    Dim folderToPutItem As String
    
    Set defaultFolderContacts = mdVariables.nameSpace.GetDefaultFolder(olFolderContacts)
    
    folderToPutItem = replaceMinorAndMajorAndAmpFromServer(getElementContent(rowBlock, "Folder", 0))
                
    If Left(folderToPutItem, 1) = "/" And Len(folderToPutItem) > 1 Then
        folderToPutItem = Mid(folderToPutItem, 2)
    End If
    
    If Right(folderToPutItem, 1) = "/" And Len(folderToPutItem) > 1 Then
        folderToPutItem = Mid(folderToPutItem, 1, Len(folderToPutItem) - 1)
    End If
    
    If folderToPutItem = "/" Then
        folderToPutItem = ""
    End If
                                                                                   
    'to test if a folder arleady exists
    Dim exists As Boolean
    Dim directories() As String
    Dim CompletePath As String
    Dim m As Integer
    Dim N As Integer
    N = -1
    CompletePath = "/"
    exists = False
    
    directories = Split(folderToPutItem, "/")
    N = UBound(directories)
                
    Set referFolder = defaultFolderContacts
    For m = 0 To N
        CompletePath = CompletePath + directories(m) + "/"
        For K = 1 To referFolder.Folders.Count
            If LCase(directories(m)) = LCase(referFolder.Folders(K).name) Then
                exists = True
                Set referFolder = referFolder.Folders(directories(m))
                Exit For
            End If
        Next K
        'folder doesn't exist. create a new one and set complete path
        If exists = False Then
            Set referFolder = referFolder.Folders.Add(directories(m))
            ReDim Preserve mdVariables.contactsFolders(UBound(mdVariables.contactsFolders) + 1)
            Dim folderInfoElement As FolderInfo
            folderInfoElement.EntryID = referFolder.EntryID
            folderInfoElement.Selected = True
            folderInfoElement.Changed = True
            folderInfoElement.name = directories(m)
            folderInfoElement.CompletePath = CompletePath
            mdVariables.contactsFolders(UBound(mdVariables.contactsFolders)) = folderInfoElement
            MkDir referFolder.EntryID
        End If
        exists = False
    Next m
    
    'add the contact int selected folder
    Dim fileas As String
    Set itemContact = referFolder.Items.Add
    'loop through newItemProperties array reading the Item properties and values to assign to the new item
    For K = 1 To UBound(props)
        
        'to get the right value for calendar birthday
        If CStr(props(K, 0)) = "FileAs" Then
            fileas = props(K, 1)
        End If
        
        If CStr(props(K, 0)) = "Subject" Then
            If props(K, 1) = Empty Or props(K, 1) = "" Then
                props(K, 1) = fileas
            End If
        End If
        
        ' This is not a duplicate!
        ' Outlook automatically converts the first char of some fields
        ' into upper-case -> to keep the original format of these fields
        ' we need to set it twice... as from GUI :)
        '
        ' Fields that need to be inserted twice:
        '   (all name fields), suffix, title, JobTitle, Company
        mdActions.letItemPropertyValue itemContact, CStr(props(K, 0)), props(K, 1)
        mdActions.letItemPropertyValue itemContact, CStr(props(K, 0)), props(K, 1)
        
    Next K

    '
    ' 'fileAs': we don't want to store empty value because some device
    ' could not support it. With this line commented, if 'fileAs' field is
    ' empty it's replaced by 'firstName' field.
    '
    'itemContact.fileas = fileas
    
    printDebugMessage "Contact Item: " + itemContact.Subject
    itemContact.Save
    createdEntryID = itemContact.EntryID
    
    insertContact = createdEntryID
    printDebugMessage "Exit insertContact method"
End Function


'From server to Outlook.
'-----------------------
' Inserts a single item, passed by a xml string, to Outlook (only for contacts)
' This is a function called from a DLL method (CALLBACK, from WindowsSyncSource.addItem)
' @param xml: the xml string for the current item
' @return   : the LUID of the inserted item
Function addItemContacts(ByVal xml As String) As String

printDebugMessage "CALLBACK: Enter addItemContacts method"

 'Get input parameters from public variables (this function is only for CONTACTS)
Dim folderType As Integer
folderType = mdVariables.FOLDER_TYPE_CON

Dim ret As String
Dim el As String
Dim ROOT As String
Dim referFolder As Outlook.MAPIFolder
Dim defaultFolderContacts As Outlook.MAPIFolder
Dim itemContact As Outlook.ContactItem

Dim position As Long
Dim numItem As Integer
Dim countInsertedItems As Integer
countInsertedItems = 0

Dim i As Integer
Dim j As Integer
Dim identifier As String
Dim rowBlock As String
Dim props() As Variant
Dim K As Integer
Dim createdEntryID As String
 
Select Case folderType
Case mdVariables.FOLDER_TYPE_CON
    ChangeStatusBar WAIT_INSERT_CONTACT + "(" + Trim(Str(countInsertedContacts + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
    ROOT = "contact"
End Select

i = 0
position = 1
numItem = 0

On Error GoTo addItemContacts_Err

Set defaultFolderContacts = mdVariables.nameSpace.GetDefaultFolder(olFolderContacts)

ret = getElementContent(xml, "NEW", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    
    numItem = getElementContent(ret, "numItems", 0)
    
    ' Expected ONLY 1 Item to add.
    If Val(numItem) = 1 Then
    
        rowBlock = getElementContent(ret, "row", position)
        identifier = getElementContent(rowBlock, "identifier", 0)
        el = getElementContent(rowBlock, ROOT, 0)
        
        If el <> Empty Then
            Dim secondValue As Variant
            
            For K = 1 To UBound(props)
                If folderType = FOLDER_TYPE_CON Then
                    
                    Dim tmp As Variant
                    
                    props(K, 0) = mdVariables.contactsProperties(K).Property
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                    props(K, 1) = tmp
                                    
                End If
                
            Next K
            
            '''''''''''''''''''''''''''''''''''''''''''''''
            createdEntryID = insertContact(rowBlock, props)
            '''''''''''''''''''''''''''''''''''''''''''''''
            
            countInsertedItems = countInsertedItems + 1
        Else
        
            printLog "Wrong format. Element dropped: " & rowBlock, INFO_LEVEL
            droppedItems = droppedItems + 1
        End If
    End If
End If

countInsertedContacts = countInsertedContacts + 1

' Return the LUID of the (only) inserted item
addItemContacts = createdEntryID

addItemContacts_Exit:
    printDebugMessage "Exit addItemContacts method"
    Exit Function
    
addItemContacts_Err:

    Dim errMsg As String
    errMsg = "Could not add item contact"
    printLog errMsg, ERROR_LEVEL
    Dim actionToDo As Integer
    Err.number = 6
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo addItemContacts_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    Case 6
        addItemContacts = "-1"
        mdMMVariables.droppedItems = mdMMVariables.droppedItems + 1
        GoTo addItemContacts_Exit
    End Select

End Function


Public Sub populateRecProps(ByRef RecProps As Variant, ByVal rowBlock As String)
            
    printDebugMessage "Enter populateRecProps method"
    Dim recurrenceType As Long
    Dim interval As Long
    Dim monthOfYear As Long
    Dim dayOfMonth As Long
    Dim dayOfWeekMask As Long
    Dim instance As Long
    Dim patternStartDate As String
    Dim patterEndDate As String
    Dim noEndDate As Boolean
    Dim startAppointment As Date
    Dim startAppointmentString As String
    Dim tmp As String
    Dim occurrences As Long
    
    Dim x, y, z As Integer
    Dim changeDay, isBackward, changeYearBackward, changeYearForward   As Boolean
    changeDay = False
    isBackward = False
    changeYearBackward = False
    changeYearForward = False
    
    startAppointmentString = mdMMVariables.getElementContent(rowBlock, "Start", 0)
    If IsDate(mdMMTimeUtils.dateToCanonical(startAppointmentString)) Then
        If InStr(startAppointmentString, "Z") <> 0 Then
            startAppointment = CDate(mdMMTimeUtils.dateToCanonical(startAppointmentString))
            x = DatePart("h", startAppointment)
            startAppointment = mdMMTimeUtils.UTCToLocal(startAppointment)
            y = DatePart("h", startAppointment)
        Else
            startAppointment = CDate(mdMMTimeUtils.dateToCanonical(startAppointmentString))
            x = DatePart("h", startAppointment)
            y = DatePart("h", startAppointment)
        End If
    ElseIf IsDate(mdMMTimeUtils.dateToCanonicalBirth(startAppointmentString)) Then
            startAppointment = CDate(mdMMTimeUtils.dateToCanonicalBirth(startAppointmentString))
            x = DatePart("h", startAppointment)
            y = DatePart("h", startAppointment)
    Else
        Exit Sub
    End If
        
    tmp = mdMMVariables.getElementContent(rowBlock, "RecurrenceType", 0)
    If tmp <> Empty And tmp <> "" Then
        recurrenceType = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "Interval", 0)
    If tmp <> Empty And tmp <> "" Then
        interval = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "DayOfMonth", 0)
    If tmp <> Empty And tmp <> "" Then
        dayOfMonth = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "MonthOfYear", 0)
    If tmp <> Empty And tmp <> "" Then
        monthOfYear = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "DayOfWeekMask", 0)
    If tmp <> Empty And tmp <> "" Then
        dayOfWeekMask = Val(tmp)
    End If
   
    tmp = mdMMVariables.getElementContent(rowBlock, "Instance", 0)
    If tmp <> Empty And tmp <> "" Then
        instance = Val(tmp)
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "PatternStartDate", 0)
    If IsDate(mdMMTimeUtils.dateToCanonical(tmp)) Then
        If InStr(tmp, "Z") <> 0 Then
            patternStartDate = mdMMTimeUtils.UTCToLocal(CDate(mdMMTimeUtils.dateToCanonical(tmp)))
        Else
            patternStartDate = CDate(mdMMTimeUtils.dateToCanonical(tmp))
        End If
    ElseIf IsDate(mdMMTimeUtils.dateToCanonicalBirth(tmp)) Then
        patternStartDate = CDate(mdMMTimeUtils.dateToCanonicalBirth(tmp))
    Else
        patternStartDate = Empty
    End If
       
    tmp = mdMMVariables.getElementContent(rowBlock, "PatternEndDate", 0)
    If IsDate(mdMMTimeUtils.dateToCanonical(tmp)) Then
        If InStr(tmp, "Z") <> 0 Then
            patterEndDate = mdMMTimeUtils.UTCToLocal(CDate(mdMMTimeUtils.dateToCanonical(tmp)))
        Else
            patterEndDate = CDate(mdMMTimeUtils.dateToCanonical(tmp))
        End If
    ElseIf IsDate(mdMMTimeUtils.dateToCanonicalBirth(tmp)) Then
        patterEndDate = CDate(mdMMTimeUtils.dateToCanonicalBirth(tmp))
    
    Else
       patterEndDate = Empty
    End If
        
    tmp = mdMMVariables.getElementContent(rowBlock, "NoEndDate", 0)
    tmp = mdMMVariables.returnElementDataTypeCorrect("NoEndDate", tmp)
    If tmp = True Then
        noEndDate = True
    Else
        noEndDate = False
    End If
    
    tmp = mdMMVariables.getElementContent(rowBlock, "Occurrences", 0)
    If Val(tmp) > 0 Then
        occurrences = Val(tmp)
    Else
        occurrences = 0
    End If
                                                    
    If x - y < 0 Then
        z = (x - y) * (-1)
    Else
        z = x - y
    End If
    
    If z > 12 Then
        changeDay = True
    Else
        changeDay = False
    End If
    
    If changeDay = True Then
        If getTimeZoneInfo = True Then
            isBackward = False
        Else
            isBackward = True
        End If
            
    End If
    
    'Assing every Value to for the property
     'Assing every Value to for the property
    RecProps(0, 0) = "RecurrenceType"
    RecProps(0, 1) = recurrenceType
    
    
    RecProps(1, 0) = "Interval"
    RecProps(1, 1) = interval
    
    
    If dayOfMonth <> 0 Then
            If changeDay = True Then
                If isBackward = True Then
                    dayOfMonth = dayOfMonth - 1
                    If dayOfMonth = 0 Then
                        If monthOfYear = 5 Or monthOfYear = 7 Or monthOfYear = 10 Then
                            ' if May, July, October the month before has 30 days
                            dayOfMonth = 30
                        Else
                            dayOfMonth = 31
                        End If
                            changeYearBackward = True
                    End If
                Else
                    dayOfMonth = dayOfMonth + 1
                    If dayOfMonth > 31 Or (dayOfMonth = 31 And (monthOfYear = 4 Or monthOfYear = 6 Or monthOfYear = 9)) Then
                        dayOfMonth = 1
                        changeYearForward = True
                    End If
                End If
            End If
            RecProps(2, 0) = "DayOfMonth"
            RecProps(2, 1) = dayOfMonth
            
     Else
        RecProps(2, 0) = "DayOfMonth"
        RecProps(2, 1) = 0
        
     End If
    
     If monthOfYear <> 0 Then
            If changeYearBackward = True Then
                monthOfYear = monthOfYear - 1
                If monthOfYear = 0 Then
                    monthOfYear = 12
                End If
            ElseIf changeYearForward = True Then
                monthOfYear = monthOfYear + 1
                If monthOfYear > 12 Then
                    monthOfYear = 1
                End If
            End If
            RecProps(3, 0) = "MonthOfYear"
            RecProps(3, 1) = monthOfYear
      Else
        RecProps(3, 0) = "MonthOfYear"
        RecProps(3, 1) = 0
            
      End If
    
      If dayOfWeekMask <> 0 Then
            ' Not used: <dayOfWeekMask> should remain the same even if we have
            ' --------- the day changed. We want to specify the days chosen for this
            '           recurrence, similar behaviour as <birthday> for contacts.
            'If changeDay = True Then
            '    If isBackward = True Then
            '        dayOfWeekMask = convertDayOfWeekMaskBackward(dayOfWeekMask)
            '    Else
            '        dayOfWeekMask = convertDayOfWeekMaskForward(dayOfWeekMask)
            '    End If
            'End If
            RecProps(4, 0) = "DayOfWeekMask"
            RecProps(4, 1) = dayOfWeekMask
     Else
        RecProps(4, 0) = "DayOfWeekMask"
        RecProps(4, 1) = 0
     End If
     
     If instance <> 0 Then
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = instance
            
     Else
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = 0
     End If
     
     RecProps(6, 0) = "PatternStartDate"
     RecProps(6, 1) = patternStartDate
     
     RecProps(7, 0) = "PatternEndDate"
     RecProps(7, 1) = patterEndDate
     
     RecProps(8, 0) = "NoEndDate"
     RecProps(8, 1) = noEndDate
     
     RecProps(9, 0) = "Occurrences"
     RecProps(9, 1) = occurrences
     
     
     printDebugMessage "Exit populateRecProps method"
End Sub

Public Function getRecurrenceValue(ByRef RecProps() As Variant, ByVal propertyName As String)

    Dim i, up As Integer
    up = UBound(RecProps)
    For i = 0 To up
        If RecProps(i, 0) = propertyName Then
            getRecurrenceValue = mdMMVariables.returnElementDataTypeCorrect(propertyName, RecProps(i, 1))
            Exit Function
        End If
        
    Next i

End Function


'From server to Outlook.
'-----------------------
' Inserts a single item, passed by a xml string, to Outlook (for calendar | tasks | notes)
' This is a function called from a DLL method (CALLBACK, from WindowsSyncSource.addItem)
' @param xml: the xml string for the current item
' @return   : the LUID of the inserted item ("-1" in case of errors)
Function addItem(ByVal xml As String) As String

printDebugMessage "CALLBACK: Enter addItem method"

'Get input parameters from public variables (which source)
Dim objFolder As Outlook.MAPIFolder
Set objFolder = mdVariables.nameSpace.GetDefaultFolder(mdVariables.currentObjFolder)
Dim folderType As Integer
folderType = mdVariables.currentFolderType

Dim ret As String
Dim el As String
Dim ROOT As String

Dim position As Long
Dim numItem As Integer
Dim countInsertedItems As Integer
countInsertedItems = 0

Dim i As Integer
Dim j As Integer
Dim identifier As String
Dim rowBlock As String
Dim props() As Variant
Dim K As Integer

Dim createdEntryID As String

Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    ChangeStatusBar WAIT_INSERT_CALENDAR + "(" + Trim(Str(countInsertedAppointments + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    ROOT = ROOT_CAL_NAME

Case mdVariables.FOLDER_TYPE_TASK
    ChangeStatusBar WAIT_INSERT_TASK + "(" + Trim(Str(countInsertedTasks + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    ROOT = "task"
    
Case mdVariables.FOLDER_TYPE_NOTE
    ChangeStatusBar WAIT_INSERT_NOTE + "(" + Trim(Str(countInsertedNotes + 1)) + ")"
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    ROOT = "note"
        
Case mdVariables.FOLDER_TYPE_CON    'error
    addItem = 0
    Exit Function
End Select


i = 0
position = 1
numItem = 0
addItem = "-1"

ret = getElementContent(xml, "NEW", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    
    numItem = getElementContent(ret, "numItems", 0)
    
    ' Expected ONLY 1 Item to add.
    If Val(numItem) = 1 Then

        rowBlock = getElementContent(ret, "row", position)
        printDebugMessage rowBlock
        logToDebug rowBlock
        identifier = getElementContent(rowBlock, "identifier", 0)
        el = getElementContent(rowBlock, ROOT, 0)
        
        If el <> Empty Then
            'numItemValid = numItemValid + 1
            
            If folderType = FOLDER_TYPE_CON Then
                'createdEntryID = mdActions.addItem(mdVariables.FOLDER_TYPE_CON, props)
            ElseIf folderType = FOLDER_TYPE_TASK Then
                props(0, 0) = "Class"
                props(0, 1) = 26
                            
             ElseIf folderType = FOLDER_TYPE_CAL Then
                props(0, 0) = "Class"
                props(0, 1) = 26
                
                'for recurrences
                Dim RecProps() As Variant
                ReDim RecProps(0 To 10, 0 To 1)
                mdMMServer2Client.populateRecProps RecProps, rowBlock
                
                'used for allDayEvent. If set then the startDate and endDate should be without time and with
                ' end date without a day
                mdMMServer2Client.setAllDayEventServer2Client "AllDayEvent", getElementContent(rowBlock, "AllDayEvent", 0)
                        
                
            End If
                               
            'for debug
            Dim subj As String
            subj = getElementContent(rowBlock, "Subject", 0)
            printDebugMessage "Item: " + subj
            '
                               
            For K = 1 To UBound(props)
                If folderType = FOLDER_TYPE_CON Then
                    Dim tmp As Variant
                    
                    props(K, 0) = mdVariables.contactsProperties(K).Property
                    tmp = returnElementDataTypeCorrect(props(K, 0), _
                        getElementContent(rowBlock, mdVariables.contactsProperties(K).Property, 0))
                    props(K, 1) = tmp
                    
                ElseIf folderType = FOLDER_TYPE_CAL Then
                        
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) Then
                            props(K, 1) = getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                            
                        Else
                            'put right type to every property. If date is empty put nothing
                            tmp = returnElementDataTypeCorrect(props(K, 0), _
                                getElementContent(rowBlock, mdVariables.calendarProperties(K).Property, 0))
                             
                            props(K, 1) = tmp
                        End If
                                                
                ElseIf folderType = FOLDER_TYPE_TASK Then
                        
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        'put right type to every property. If date is empty put nothing
                        tmp = returnElementDataTypeCorrect(props(K, 0), _
                         getElementContent(rowBlock, mdVariables.tasksProperties(K).Property, 0))
                        props(K, 1) = tmp
                
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    If mdVariables.notesProperties(K).Property <> "Subject" Then
                        
                        Dim tmpNote As Variant
                        'props(K, 0) = mdVariables.notesProperties(K).Property
                        'tmpNote = defaultNoteValues(props(K, 0), getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0))
                        'props(K, 1) = tmpNote
                        
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        tmp = returnElementDataTypeCorrect(props(K, 0), _
                         getElementContent(rowBlock, mdVariables.notesProperties(K).Property, 0))
                        tmpNote = defaultNoteValues(props(K, 0), tmp)
                        props(K, 1) = tmpNote

                    End If
                
                End If
                
            Next K
                                      
            ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            createdEntryID = mdActions.addItem(mdVariables.currentFolderType, props)
            ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

            If createdEntryID = "-1" Then 'error in adding an item. log it at info level
                printLog ERROR_INSERTING_NEW_ITEM & rowBlock, INFO_LEVEL
                droppedItems = droppedItems + 1
                addItem = "-1"
            Else
                countInsertedItems = countInsertedItems + 1
                ' Return the LUID of the (only) inserted item
                addItem = createdEntryID
            End If
        Else
        
            printLog "Wrong format. Element dropped: " & rowBlock, INFO_LEVEL
            droppedItems = droppedItems + 1
        End If
    End If
End If


Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    countInsertedAppointments = countInsertedAppointments + 1
Case mdVariables.FOLDER_TYPE_TASK
    countInsertedTasks = countInsertedTasks + 1
Case mdVariables.FOLDER_TYPE_NOTE
    countInsertedNotes = countInsertedNotes + 1
End Select

printDebugMessage "Exit addItem method"

End Function


'From server to Outlook.
'-----------------------
' Deletes a single item, passed by a xml string, in Outlook (for all sources)
' This is a function called from a DLL method (CALLBACK, from WindowsSyncSource.deleteItem)
' @param xml: the xml string for the current item
' @return   : "0" if no errors
Function deleteItem(ByVal xml As String) As String

printDebugMessage "CALLBACK: Enter deleteItem method"

'Get input parameters from public variables (which source)
Dim objFolder As Outlook.MAPIFolder
Set objFolder = mdVariables.nameSpace.GetDefaultFolder(mdVariables.currentObjFolder)
Dim folderType As Integer
folderType = mdVariables.currentFolderType

Dim ret As String
Dim res As String

Dim position As Long
Dim numItem As Integer
Dim i As Integer
Dim identifier As String
Dim rowBlock As String

i = 0
position = 1
deleteItem = "-1"


Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    ChangeStatusBar WAIT_DELETE_CALENDAR + "(" + Trim(Str(countDeletedAppointments + 1)) + ")"
Case mdVariables.FOLDER_TYPE_TASK
    ChangeStatusBar WAIT_DELETE_TASK + "(" + Trim(Str(countDeletedTasks + 1)) + ")"
Case mdVariables.FOLDER_TYPE_NOTE
    ChangeStatusBar WAIT_DELETE_NOTE + "(" + Trim(Str(countDeletedNotes + 1)) + ")"
Case mdVariables.FOLDER_TYPE_CON
    ChangeStatusBar WAIT_DELETE_CONTACT + "(" + Trim(Str(countDeletedContacts + 1)) + ")"
End Select


ret = getElementContent(xml, "DEL", 0)
If ret <> "-1" And ret <> "" And ret <> Empty Then
    numItem = getElementContent(ret, "numItems", 0)
    
    ' Expected ONLY 1 item to delete
    If Val(numItem) = 1 Then

        rowBlock = getElementContent(ret, "row", position)
        identifier = getElementContent(rowBlock, "identifier", 0)
        res = mdActions.removeItem(identifier)
        deleteItem = res
        
    End If

End If


Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    countDeletedAppointments = countDeletedAppointments + 1
Case mdVariables.FOLDER_TYPE_TASK
    countDeletedTasks = countDeletedTasks + 1
Case mdVariables.FOLDER_TYPE_NOTE
    countDeletedNotes = countDeletedNotes + 1
Case mdVariables.FOLDER_TYPE_CON
    countDeletedContacts = countDeletedContacts + 1
End Select

printDebugMessage "Exit deleteItem method"

End Function

