Attribute VB_Name = "mdUnload"
'
' Copyright (C) 2003-2006 Funambol
'
' This program is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdUnload.bas                                         *
'*                                                              *
'*This module contains all the functions used during the unload *
'*procedure for the Project.                                    *
'*These functions were the last actions done before closing the *
'*program: closing all the opened files and logoff from MAPI    *
'*session.                                                      *
'****************************************************************

Option Explicit

Public Sub closeProgram()

Dim i As Integer

On Error GoTo closeProgram_Err

logToDebug "closing procedure"
printLog "Exit program", INFO_LEVEL

Close 'close all opened files

'close the Outlook MAPI Session opened
If Not mdVariables.nameSpace Is Nothing Then
    On Error Resume Next
    mdVariables.nameSpace.Logoff
    logToDebug "Logged off; reset global variables"
    'printDebugMessage "Logged off from Outlook"
Else
    logToDebug "No active session"
End If

' Clean up shared objects
Dim Utils As Redemption.MAPIUtils
Set Utils = CreateObject("Redemption.MAPIUtils")
Utils.Cleanup

Dim dimArray As Long


'read the folders arrays in order to seach for the not selected ones
'to compare with the existent disk folders.
'If found a folder not currently selected, it will be deleted

dimArray = -1
dimArray = UBound(mdVariables.calendarFolders)
For i = 0 To dimArray
    If Not mdVariables.calendarFolders(i).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.calendarFolders(i).EntryID) Then
                ChDir mdVariables.calendarFolders(i).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.calendarFolders(i).EntryID
        End If
    End If
Next i
dimArray = -1
dimArray = UBound(mdVariables.contactsFolders)
For i = 0 To dimArray
    If Not mdVariables.contactsFolders(i).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.contactsFolders(i).EntryID) Then
                ChDir mdVariables.contactsFolders(i).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.contactsFolders(i).EntryID
        End If
    End If
Next i

dimArray = -1
dimArray = UBound(mdVariables.mailFolders)
For i = 0 To dimArray
    If Not mdVariables.mailFolders(i).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.mailFolders(i).EntryID) Then
                ChDir mdVariables.mailFolders(i).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.mailFolders(i).EntryID
        End If
    End If
Next i

dimArray = -1
dimArray = UBound(mdVariables.tasksFolders)
For i = 0 To dimArray
    If Not mdVariables.tasksFolders(i).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.tasksFolders(i).EntryID) Then
                ChDir mdVariables.tasksFolders(i).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.tasksFolders(i).EntryID
        End If
    End If
Next i

dimArray = -1
dimArray = UBound(mdVariables.notesFolders)
For i = 0 To dimArray
    If Not mdVariables.notesFolders(i).Selected Then
        If mdFileSystem.doesFolderExist(mdVariables.notesFolders(i).EntryID) Then
                ChDir mdVariables.notesFolders(i).EntryID 'delete the relative folder if exsists
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.notesFolders(i).EntryID
        End If
    End If
Next i


closeProgram_End:
    End
    
    'Exit Sub

closeProgram_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        printLog "Error occurred in closing procedure", ERROR_LEVEL
        GoTo closeProgram_End
    Case 1
        Resume
    Case 2
        Resume Next
    Case 6
        printLog "Error occurred in closing procedure", ERROR_LEVEL
        GoTo closeProgram_End
    End Select

End Sub
