/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_SYNC_OUTLOOKCONFIG
    #define INCL_SYNC_OUTLOOKCONFIG

	#include "base/Log.h"

	// property definitions for Outlook Client
	#define SPDM_SYNCURL							  T("spdm.syncURL")
	#define SPDM_SERVERNAME   						  T("spdm.serverName")
	#define SPDM_PASSWORD     						  T("spdm.password")
	#define SPDM_USERNAME     						  T("spdm.username")
	#define SPDM_DEVICEID	  						  T("spdm.deviceId")
	#define SPDM_ENCRYPTION   						  T("spdm.encryption")
    #define SPDM_USE_PROXY                            T("spdm.useProxy")
    #define SPDM_PROXY_USERNAME                       T("spdm.proxyUsername")
    #define SPDM_PROXY_PASSWORD                       T("spdm.proxyPassword")

	#define SYNC_CONTACTS     						  T("sync.contacts")
	#define SYNC_APPOINTMENTS 						  T("sync.appointments")
    #define SYNC_TASKS        						  T("sync.tasks")
    #define SYNC_NOTES        						  T("sync.notes")

	// names of properties
    #define PROPERTY_LOG_LEVEL						  T("logLevel")
	#define PROPERTY_USESIF							  T("useSIF")				// <- Better: moving to \common\spdm\constants.h ?
	#define PROPERTY_INSTALL_DIR					  T("installDir")

	// paths in DMTree
	#define APPLICATION_URI							  T("Funambol/SyncClientOutlook")
	#define CONTEXT_SYNCML            				  T("spds/syncml")
	#define CONTEXT_SOURCES           				  T("spds/sources")
	#define CONTEXT_CONTACTS       					  T("spds/sources/contacts")
	#define CONTEXT_APPOINTMENTS   					  T("spds/sources/appointments")
    #define CONTEXT_TASKS          					  T("spds/sources/tasks")
	#define CONTEXT_NOTES							  T("spds/sources/notes")




	//#define ERRMSG_CONF_NOT_FOUND   T("Configuration not found. DM context: %s")




	/******************************************************************************
	 * Class OutlookConfig:
	 * implements methods to access configuration parameters for Outlook Client,
	 * stored in windows registry.
	 * Note: all methods are based on char strings.
	 *      (API 3.0 based on char strings, VB calls also based on char strings)
	 ******************************************************************************
	*/
	class __declspec(dllexport) OutlookConfig {

	public:

		OutlookConfig();
        ~OutlookConfig();

		// To get/set a property value under a specific path 'nodeContext'.
		int getPropertyValue        (const char* nodeContext, const char* propertyName, char* propertyValue);
		int setPropertyValue        (const char* nodeContext, const char* propertyName, const char* propertyValue);

		// To get/set a specific syncml configuration property value.
		int getConfigPropertyValue  (const char* spdmName, char* propertyValue);
		int setConfigPropertyValue  (const char* spdmName, const char* propertyValue);

		// To get/set a syncsource property value.
		int getSourcePropertyValue  (const char* sourceName, const char* propertyName, char* propertyValue);
		int setSourcePropertyValue  (const char* sourceName, const char* propertyName, const char* propertyValue);

	};

#endif